unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, atScript, atScripter,ap_Classes, ap_Dialogs, atPascal,
  ap_StdCtrls, ap_Controls, ap_ExtCtrls, ap_Forms, ap_Graphics,
 System.ImageList, ap_ImgList, VCL.TMSFNCButton;

type
  TForm1 = class(TForm)
    atScripter1: TatScripter;
    Button1: TButton;

    procedure Button1Click(Sender: TObject);
    procedure PrepareScripter;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;


implementation
uses VCL.ScriptForm,VCL.ScripterInit;

{$R *.dfm}

function ConvertDFMToSingleSaveEvents(const DFMContent: TStringList)
  : TStringList;
var
  i: Integer;
  EventLines: TStringList;
  Line, ComponentName, EventName, EventHandler: string;
  InObject: Boolean;
begin
  Result := TStringList.Create;
  EventLines := TStringList.Create;
  InObject := False;
  try
    for i := 0 to DFMContent.Count - 1 do
    begin
      Line := DFMContent[i].Trim;

      // Olaylar kontrol et ve EventLines'e ekle
      if InObject and Line.StartsWith('On') then
      begin
        // rnein: OnClick = Button1Click
        EventName := Line.Split(['='])[0].Trim;
        EventHandler := Line.Split(['='])[1].Trim;
        EventLines.Add(Format('%s.%s=%s', [ComponentName, EventName,
          EventHandler]));
        Continue;
      end;

      // Nesne balarken ComponentName'i al
      if Line.StartsWith('object') then
      begin
        InObject := True;
        ComponentName := Line.Split([':'])[0].Trim;
        ComponentName := StringReplace(ComponentName, 'Object', '',
          [rfReplaceAll, rfIgnoreCase]);

        ComponentName := Trim(ComponentName);
        if ComponentName = 'Form1' then
          ComponentName := 'Self';

      end;

      // Nesne bittiinde, InObject'i false yap
      if Line = 'end' then
      begin
        InObject := False;
      end;

      // Sonu listesine satr ekle
      Result.Add(DFMContent[i]);
    end;

    // Tm olaylar tek bir SaveEvents.Strings blouna ekle
    if EventLines.Count > 0 then
    begin
      // SaveEvents.Strings'i Result'n en bana ekle
      Result.Insert(1, '  SaveEvents.Strings = (');
      for var j := 0 to EventLines.Count - 1 do
      begin
        Result.Insert(2 + j, '    ''' + EventLines[j] + '''');
      end;
      Result.Insert(2 + EventLines.Count, '  )');
    end;
  finally
    EventLines.Free;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  MainFile, LibFile, DFMFile, ConvertDFM: TStringList;
begin
  MainFile := TStringList.Create;
  MainFile.LoadFromFile
    ('C:\Users\Administrator\Documents\Embarcadero\Studio\Projects\VCLScripter\MainFile.txt');

  // ShowMessage(MainFile.Text);
  LibFile := TStringList.Create;
  LibFile.LoadFromFile
    ('C:\Users\Administrator\Documents\Embarcadero\Studio\Projects\VCLScripter\LibFile.txt');

  DFMFile := TStringList.Create;
  DFMFile.LoadFromFile
    ('C:\Users\Administrator\Documents\Embarcadero\Studio\Projects\VCLScripter\DFMFile.txt');

  ConvertDFM := ConvertDFMToSingleSaveEvents(DFMFile);
  // ConvertDFM := DFMFile;
  // ShowMessage(ConvertDFM.Text);

  PrepareScripter;

  atScripter1.SourceCode := MainFile;

  With atScripter1.AddScript(slPascal) Do
  Begin
    UnitName := 'FormLib';
    SourceCode := LibFile;
    DesignFormResource := ConvertDFM.Text;

    ShowMessage(ScriptInfo.DesignInfo.ToString);
    ScriptInfo.FormResource := ConvertDFM.Text;
    ShowMessage(ConvertDFM.Text);
    SelfRegisterAsLibrary(UnitName);
    Compile;
  end;
  atScripter1.Execute;
end;

procedure TForm1.PrepareScripter;
begin
  with atScripter1 do
  begin
    Clear;
    ScriptInfo.Clear;

    AddLibrary(TatClassesLibrary);
    AddLibrary(TatExtCtrlsLibrary);
    AddLibrary(TatControlsLibrary);
    AddLibrary(TatGraphicsLibrary); // Adding graphics library may be necessary
    AddLibrary(TatImgListLibrary); // Ensure the imagelist library is added

    DefineClassByRTTI(TScriptForm, roInclude);
    DefineClassByRTTI(TForm);
    DefineClassByRTTI(TComponent);
    DefineClassByRTTI(TPersistent);
    DefineClassByRTTI(TImageList);
    DefineClassByRTTI(TButton);
    DefineClassByRTTI(TTMSFNCButton);
    // AddComponents(TTMSFNCCustomComponent);

    EventSupport := True;
    AddObject('Application', Application);
    if Self <> Nil then
    Begin
      atScripter1.AddObject('Self', Self);
    End;
  end;

end;

end.
